Linode Debian + rvm + nginx + Unicorn 在启动时杀死 master 或者不启动 unicorn

Linode Debian + rvm + nginx + Unicorn 在启动时杀死 master 或者不启动 unicorn

我是运行 Debian 6 的新 Linode/Linux 用户。我试图让我的 Unicorn 服务器在启动时启动,但出于某种原因它没有启动,而且我无法找到任何错误消息。Nginx 启动正常,并且我安装了多用户 RVM。我的直觉是它与 RVM 有关。这是我的unicorn_init.sh文件/rails/todo,在 处有一个指向它的符号链接/etc/init.d/unicorn

# unicorn_init.sh
#!/bin/sh

set -e

TIMEOUT=${TIMEOUT-60}
APP_ROOT=/rails/todo
PID=$APP_ROOT/tmp/pids/unicorn.pid
CMD="$APP_ROOT/bin/unicorn_rails -D -c $APP_ROOT/config/unicorn.rb -E production"
GEM_HOME="/usr/local/rvm/gems/ruby-1.9.2-p290@global"
action="$1"
set -u

old_id="$PID.oldbin"

cd $APP_ROOT || exit 1
export GEM_HOME=$GEM_HOME

sig () {
  test -s "$PID" && kill -$1 `cat $PID`
}

oldsig () {
  test -s $old_pid && kill -$1 `cat $old_pid`
}

case $action in
  start)
    sig 0 && echo >&2 "Already running" && exit 0
    su -c "$CMD" - root
    ;;
  stop)
    sig QUIT && exit 0
    echo >&2 "Not running"
    ;;
  force-stop)
    sig TERM && exit 0
    echo >&2 "Not running"
    ;;
  restart|reload)
    sig HUP && echo reloaded OK && exit 0
    echo >&2 "Couldn't reload, starting '$CMD' instead"
    su -c "$CMD" - root
    ;;
  upgrade)
    if sig USR2 && sleep 2 && sig 0 && oldsig QUIT
    then
      n=$TIMEOUT
      while test -s $old_pid && test $n -ge 0
      do
        printf '.' && sleep 1 && n=$(( $n - 1 ))
      done
      echo

      if test $n -lt 0 && test -s $old_pid
      then
        echo >&2 "$old_pid still exists after $TIMEOUT seconds"
        exit 1
      fi
      exit 0
    fi
    echo >&2 "Couldn't upgrade, starting '$CMD' instead"
    su -c "$CMD" - root
    ;;
  reopen-logs)
    sig USR1
    ;;
  *)
    echo >&2 "Usage: $0 <start|stop|restart|upgrade|force-stop|reopen-logs>"
    exit 1
    ;;
esac

我的设置已经完成了 99% — 如能提供任何建议我将非常感激。


更新

以下是输出$ update-rc.d unicorn defaults

update-rc.d: using dependency based boot sequencing
insserv: warning: script 'unicorn' missing LSB tags and overrides
insserv: There is a loop between service nginx and unicorn if stopped
insserv:  loop involving service unicorn at depth 2
insserv:  loop involving service nginx at depth 1
insserv: Stopping unicorn depends on nginx and therefore on system facility `$all' which can not be true!
insserv: exiting now without changing boot order!
update-rc.d: error: insserv rejected the script header

答案1

Shebang(#!/bin/sh)应该是脚本的第一行

編輯:

请将以下内容放在 shebang 之后和任何应用程序特定设置之前

### BEGIN INIT INFO
# Provides:          APPLICATION
# Required-Start:    $all
# Required-Stop:     $network $local_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Start the APPLICATION unicorns at boot
# Description:       Enable APPLICATION at boot time.
### END INIT INFO
# 
# Use this as a basis for your own Unicorn init script.
# Make sure that all paths are correct.

set -u
set -e

它肯定应该摆脱 LSB 警告。

相关内容